version: "3.7"
services:
  prometheus:
    image: prom/prometheus:latest
    container_name: prometheus
    restart: unless-stopped
    user: root
    volumes:
      - ./data/prometheus/config:/etc/prometheus/
      - ./data/prometheus/data:/prometheus
    command:
      - '--config.file=/etc/prometheus/prometheus.yml'
      - '--storage.tsdb.path=/prometheus'
      - '--web.console.libraries=/etc/prometheus/console_libraries'
      - '--web.console.templates=/etc/prometheus/consoles'
      - '--storage.tsdb.retention.time=200h'
      - '--web.enable-lifecycle'
      - '--web.external-url=http://{{ansible_default_ipv4.address}}:9090'
    networks:
      - monitoringnet

    links:
      - cadvisor:cadvisor
      - node-exporter:node-exporter
      - alertmanager:alertmanager
      - pushgateway:pushgateway
{% if exposed_ports %}
    ports:
      - 9090:9090
{% endif %}


  alertmanager:
    image: prom/alertmanager:latest
    container_name: alertmanager

    volumes:
      - ./data/alertmanager:/etc/alertmanager
     # - ./data/alertmanager/data:/alertmanager
    command:
      - '--config.file=/etc/alertmanager/config.yml'
      - '--storage.path=/alertmanager'
    restart: unless-stopped
    networks:
      - monitoringnet
{% if exposed_ports %}
    ports:
      - 9093:9093
{% endif %}

  node-exporter:
    image: prom/node-exporter:latest
    container_name: nodeexporter
    restart: unless-stopped
    volumes:
      - /proc:/host/proc:ro
      - /sys:/host/sys:ro
      - /:/rootfs:ro
    command:
      - '--path.procfs=/host/proc'
      - '--path.rootfs=/rootfs'
      - '--path.sysfs=/host/sys'
      - '--collector.filesystem.mount-points-exclude=^/(sys|proc|dev|host|etc)($$|/)'
    networks:
      - monitoringnet
{% if exposed_ports %}
    ports:
      - 9100:9100
{% endif %}


  cadvisor:
    image: google/cadvisor:latest
    container_name: cadvisor
    restart: unless-stopped
    volumes:
      - /:/rootfs:ro
      - /var/run:/var/run:rw
      - /sys:/sys:ro
      - /var/lib/docker/:/var/lib/docker:ro
    networks:
      - monitoringnet
{% if exposed_ports %}
    ports:
      - 8080:8080
{% endif %}

  pushgateway:
    image: prom/pushgateway:latest
    container_name: pushgateway
    restart: unless-stopped
#    expose:
#      - 9091
{% if exposed_ports %}
    ports:
      - 9091:9091
{% endif %}
    networks:
      - monitoringnet

  blackbox:
    image: prom/blackbox-exporter:latest
    container_name: blackbox
    restart: unless-stopped
    command:
      - "--config.file=/etc/blackbox/blackbox.yml"
    networks:
      - monitoringnet
{% if exposed_ports %}
    ports:
      - 9115:9115
{% endif %}
    volumes:
      - ./data/blackbox/blackbox.yml:/etc/blackbox/blackbox.yml
  
  grafana:
    image: grafana/grafana:8.2.5
    container_name: grafana
    restart: unless-stopped
    links:
      - prometheus:prometheus
    volumes:
      - ./data/grafana:/var/lib/grafana
      - ./data/grafana/provisioning/dashboards:/etc/grafana/provisioning/dashboards
      - ./data/grafana/provisioning/datasources:/etc/grafana/provisioning/datasources
{% if exposed_ports %}
    ports:
      - 3000:3000
{% endif %}
    environment:
      - GF_SECURITY_ADMIN_PASSWORD={{grafana_pw}}
      - GF_USERS_ALLOW_SIGN_UP=false
      - GF_SERVER_DOMAIN=grafana.{{domain}}
{% if traefik %}
    labels:
      - "traefik.enable=true"
      - "traefik.http.routers.grafana.rule=Host(`grafana.{{domain}}`)"
      - "traefik.http.routers.grafana.tls=true"
      - "traefik.http.routers.grafana.tls.certresolver={{traefik_resolver}}"
      - "traefik.http.routers.grafana.entrypoints=websecure"
      - "traefik.http.routers.grafana.tls.options=default"
      - "traefik.http.routers.grafana.middlewares=https-redirect@file,security-headers@file"
      - "traefik.http.routers.grafana-insecure.rule=Host(`grafana.{{domain}}`)"
      - "traefik.http.routers.grafana-insecure.middlewares=https-redirect@file,security-headers@file"
      - "traefik.http.routers.grafana-insecure.entrypoints=web"
      - "traefik.http.services.grafana.loadbalancer.server.port=3000"
      - "traefik.http.routers.grafana.service=grafana"
      - "traefik.http.routers.grafana-insecure.service=grafana"
      - "traefik.docker.network=traefiknet"
{% endif %}
    networks:
{% if traefik %}
      - traefiknet
{% endif %}
      - monitoringnet


networks:
{% if traefik %}
  traefiknet:
    external:
      name: traefiknet
{% endif %}
  monitoringnet:
    name: monitoring_network
